/*
 * dv_utils.h
 *
 *
 * 	Greated for:
 *	IMPROVEMENT: Excel PowerPivot is unable to show the list of tables from PostgresODBC
 *	ISSUE: REPIN-28
 *	SOLUTION: show the list of tables
 *	CREATED BY: Kopychenko Pavel
 *
 *  Created on: 04.03.2013
 *      Author: Pavel kopychenko
 */

#ifndef DV_UTILS_H_
#define DV_UTILS_H_

/* Predicat for compare started pisition and fragmet */
int cmpSubStr(int i, const char* str, int len , const char* subStr);

/* Roling strig to left */
void rolStr(char* str, int len, int i, int c);

/* Replace in string pisition */
int replaceStr(char* str, int len, int i, char* subStr, int l);

/* Replace query by replacement rules */
void replaceAllQueryForDV(char* str);

void clearBackSlash(char* str);


#define MARK_BASE "#{base}"
#define MARK_SCHEME "#{scheme}"
#define MARK_TABLE "#{table}"
#define MARKS_COUNT 3



char* qpbuff[100][3];
char newQuery[100000];

#define POINT_TYPE_STR "s"
#define POINT_TYPE_PAR "p"


void setPbuff(char* pbuff[][3], int i, char* type, char* ptr , char* value);

char* getBbuffType(char* pbuff[][3], int i);

char* getBbuffPtr(char* pbuff[][3], int i);

void cleanPbuff(char* pbuff[][3]);

void cleanQuery(char * query , int len);

void splitQuery(char * query, char* pbuff[][3]);

int cmpQuerys(char* query, char* pbuff[][3]);

void parseQuery(char* query, char* pbuff[][3]);

char* addPar(char* str, char* pbuff[][3], char* par);

void cleanStr(char* str, int len);


#endif /* DV_UTILS_H_ */
